unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,Jobs,
  StdCtrls,TypInfo, Db, DBTables, DBCtrls;

type
  TForm1 = class(TForm)
    btnSaveToDisk: TButton;
    btnLoadFromDisk: TButton;
    Memo: TMemo;
    btnSaveToDB: TButton;
    btnLoadFromDB: TButton;
    tblDB: TTable;
    tblDBDATA: TBlobField;
    tblDBF: TTable;
    btnSaveToDBF: TButton;
    btnLoadFromDBF: TButton;
    tblDBFDATA: TBlobField;
    ClearMemo: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnSaveToDiskClick(Sender: TObject);
    procedure btnLoadFromDiskClick(Sender: TObject);
    procedure btnSaveToDBClick(Sender: TObject);
    procedure btnLoadFromDBClick(Sender: TObject);
    procedure btnSaveToDBFClick(Sender: TObject);
    procedure btnLoadFromDBFClick(Sender: TObject);
    procedure ClearMemoClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure FillJobHolder;
    procedure FillMemoFromJobHolder;
  end;

var
  Form1: TForm1;
  JobHolder:TJobHolder;
  FileName:string;

implementation

{$R *.DFM}



{-----------------------FormCreate--------------------------------------------

------------------------------------------------------------------------------}
procedure TForm1.FormCreate(Sender: TObject);
begin

 RegisterClass(TJobHolder);                       // do no forget this
 JobHolder:=TJobHolder.Create(Self);

 FileName:= ExtractFileDir(Application.ExeName) + '\Job.txt';

 with tblDB do
 begin
   DataBaseName:=ExtractFileDir(Application.ExeName);
   TableName:='Data_DB.DB';
   Open;
 end;

 with tblDBF do
 begin
   DataBaseName:=ExtractFileDir(Application.ExeName);
   TableName:='DATA_DBF.DBF';
   Open;
 end;

end;



{--------------------------FormClose------------------------------------------

------------------------------------------------------------------------------}
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  JobHolder.Free;
  tblDB.Close;
  tblDBF.Close;
end;



{-------------------------FillAJobHolder--------------------------------------

------------------------------------------------------------------------------}
procedure TForm1.FillJobHolder;
var
 i:integer;
begin

  with JobHolder.JobLabel do
  begin
    JobName:='Name';
    Job_ID:='ID';
    JobType:=jtNormal;
  end;

  for i:=0 to 9 do
  with JobHolder do
  begin
    Jobs.Add;
    with Jobs.Items[i] do
    begin
      aIndex      :=i;
      aName       :='Job ' + IntToStr(i);
      Full        :=True;
      with SecondLayer do
      begin
        aString     :='Job ' + IntToStr(i);
        aRect      :=Rect(0,0,0,0);
        aSet       :=[meOne, meFive];

        with Jobs[i].SecondLayer.ThirdLayer do
        begin
          S      :='ThirdLayer ' + IntToStr(i);
          I      :=i;
          B      :=True;
          F      :=1.0;
        end;

      end;
    end; 
  end;

end;  { FillJobHolder  }




{----------------------FillMemoFromJobHolder-------------------------------------

------------------------------------------------------------------------------}
procedure TForm1.FillMemoFromJobHolder;
var
 i:integer;
begin
                   //GetEnumName (TypeInfo (TIcoElement), Ord (Element));
  with Memo.Lines ,JobHolder.JobLabel do           // Add();
  begin
    Add('==== JobHolder.JobLabel ===');
    Add('JobName     ' + JobName);
    Add('Job_ID      ' + Job_ID);
    Add('JobType     ' + GetEnumName (TypeInfo (TJobType), Ord (JobType)));
    Add('');
  end;

  for i:=0 to 9 do
  with Memo.Lines , JobHolder.Jobs.Items[i] do
  begin
    Add('=== ' + 'Item ' +  IntToStr(i) + ' ===');
    Add('aIndex       ' + IntToStr(aIndex) );
    Add('aName        ' + aName);
    Add('Full         ' + GetEnumName (TypeInfo (boolean), Ord (Full)));
    Add('');
    Add('SecondLayer        ');
    Add('aString       ' + SecondLayer.aString);
    Add('');
    Add('ThirdLayer        ');
    Add('S               ' + SecondLayer.ThirdLayer.S);
    Add('I               ' + IntToStr( SecondLayer.ThirdLayer.I));
    Add('B               ' + GetEnumName (TypeInfo (boolean), Ord (SecondLayer.ThirdLayer.B)));
    Add('');
  end;

end;  { FillMemoFromJobHolder  }





{-----------------btnSaveToDiskClick--------------------------------------------

------------------------------------------------------------------------------}
procedure TForm1.btnSaveToDiskClick(Sender: TObject);
var
  Stream        : TFileStream;
begin

   FillJobHolder;

   Stream := TFileStream.Create( FileName, fmCreate );
   try
     Stream.WriteComponent(JobHolder);
   finally
     Stream.Free;
   end;

end;


{----------------btnLoadFromDiskClick-------------------------------------------

------------------------------------------------------------------------------}
procedure TForm1.btnLoadFromDiskClick(Sender: TObject);
var
 Stream : TFileStream;
begin

   Stream := TFileStream.Create(FileName, fmOpenRead);
   try
     JobHolder:= Stream.ReadComponent( nil ) as TJobHolder;
   finally
     Stream.Free;
   end;

   FillMemoFromJobHolder;

end;





{----------------btnSaveToDBClick----------------------------------------------

------------------------------------------------------------------------------}
procedure TForm1.btnSaveToDBClick(Sender: TObject);
var
  BlobStream        : TBlobStream;
begin

   FillJobHolder;

   tblDB.Edit;                                              // do no forget this
   BlobStream := TBlobStream.Create(tblDBDATA, bmWrite);
   try
     BlobStream.WriteComponent(JobHolder);
   finally
     BlobStream.Free;
   end;
   tblDB.Post;                                              // do no forget this

end;


{----------------btnLoadFromDBClick---------------------------------------------

------------------------------------------------------------------------------}
procedure TForm1.btnLoadFromDBClick(Sender: TObject);
var
 BlobStream : TBlobStream;
begin

   BlobStream := TBlobStream.Create(tblDBDATA, bmRead);
   try
     JobHolder:= BlobStream.ReadComponent( nil ) as TJobHolder;
   finally
     BlobStream.Free;
   end;

   FillMemoFromJobHolder;

end;




{----------------btnSaveToDBFClick--------------------------------------------

------------------------------------------------------------------------------}
procedure TForm1.btnSaveToDBFClick(Sender: TObject);
var
  BlobStream        : TBlobStream;
begin

   FillJobHolder;

   tblDBF.Edit;
   BlobStream := TBlobStream.Create(tblDBFDATA, bmWrite);
   try
     BlobStream.WriteComponent(JobHolder);
   finally
     BlobStream.Free;
   end;     
   tblDBF.Post;

end;


{----------------btnLoadFromDBFClick--------------------------------------------

------------------------------------------------------------------------------}
procedure TForm1.btnLoadFromDBFClick(Sender: TObject);
var
 BlobStream : TBlobStream;
begin

   BlobStream := TBlobStream.Create(tblDBFDATA, bmRead);
   try
     JobHolder:= BlobStream.ReadComponent( nil ) as TJobHolder;
   finally
     BlobStream.Free;
   end;

   FillMemoFromJobHolder;
   
end;



{----------------ClearMemoClick------------------------------------------------

------------------------------------------------------------------------------}
procedure TForm1.ClearMemoClick(Sender: TObject);
begin
  Memo.Lines.CLear;        
end;

end.



 







